package controll;

import java.io.IOException;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import bean.OrderListBean;
import dbutil.DBConnection;
import util.TransformationMoney;

/**
 * Servlet implementation class OrderListControll
 */
public class OrderListControll extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public OrderListControll() {
        super();
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
		response.getWriter().append("Served at: ").append(request.getContextPath());
		
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
		request.setCharacterEncoding("UTF-8");
		response.setContentType("text/html;charset=UTF-8");
		String request_uri = request.getRequestURI().trim();
		System.out.println("request_uri:"+request_uri);
		String path = request_uri.substring(request_uri.indexOf("/", 1), request_uri.indexOf("."));
		OrderListBean orderListBean ;
		
		List<OrderListBean> orderList = new ArrayList<OrderListBean>();
		String sql = "select * from mt_order where orderstate = 2 order by id DESC" ;
	//	String sql = "select * from mt_order where orderstate = 2  and ordernumber='P19070310263401'" ;
		if("/OrderListControll".equals(path)) {
			Connection con = new DBConnection().getConnection();		
			ResultSet rs ;
			try {
				Statement stmt  = con.createStatement();
				rs = stmt.executeQuery(sql);
				if(rs!=null) {
					while(rs.next()) {
						orderListBean = new OrderListBean();
						int id = rs.getInt("id");
						String orderNumber = rs.getString("ordernumber");
						String payName = rs.getString("payname");
						int supplierId = rs.getInt("supplierid");
						float payAmt = rs.getFloat("payamt");
						int  orderstate = rs.getInt("orderstate");
						String orderdate = rs.getString("orderdate");
						
						orderListBean.setId(id);
						orderListBean.setOrdernumber(orderNumber);
						orderListBean.setPayName(payName);
						orderListBean.setSupplierid(supplierId);
						orderListBean.setPayamt(payAmt);
						orderListBean.setOrderstate(orderstate);
						orderListBean.setOrderdate(orderdate);
						
						//查询采购订单明细
						String sql_mt_order_sku = "select * from mt_order_sku where orderid="+orderListBean.getId();
					//	String sql_mt_order_sku = "select * from mt_order_sku where orderid=731";  
						Statement stmt1= con.createStatement();
						ResultSet rs1 = stmt1.executeQuery(sql_mt_order_sku);
						float totalMoney = 0.0f ; //定义一个采购订单有N条采购商品。
						TransformationMoney transformationMoeny = new TransformationMoney();  //声明钱转换格式实例
						if(rs1!=null) {
							int count = 0 ;
							while(rs1.next()) {							
								count = ++count;   //N条采购订单标记位
								int orderamt = rs1.getInt("orderamt");  //采购数量
								float specprice = rs1.getFloat("specprice"); //单个商品规格报价
								float amount = rs1.getFloat("amount");  //单个商品商品总价
								orderListBean.setOrderamt(orderamt);
								orderListBean.setSpecprice(specprice);
								orderListBean.setAmount(amount);
								boolean flag_skuAmount = orderListBean.isFlagAmount() ;  //判断该采购单单笔明细是否与实际钱数一致。
								orderListBean.setFlag_skuAmount(flag_skuAmount);
								if(flag_skuAmount==true && count>1) {
									totalMoney +=orderListBean.getAmount();   //有个采购订单有N条采购商品，计算其总价。
								} else {
									totalMoney += orderListBean.getAmount();   //否则采购订单总额就等于单个商品的总额
									if(orderListBean.isFlag_total()==false){
										orderListBean.setFlag_total(false);  //设置总的钱数为false
									}
									
								}
							}
						}
						totalMoney = transformationMoeny.transformationMoney(totalMoney);
						orderListBean.setExpected(totalMoney);
						boolean isFlag_total = orderListBean.isFlag_total();  //判断合同金额与实际金额是否一致
						if(isFlag_total==true) {
							orderListBean.setFlag_total(true);
						} else {
							orderListBean.setFlag_total(false);
						}
						orderList.add(orderListBean);
					}
					
				}
				
				request.setAttribute("orderList", orderList);
				
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				try {
					con.close();
				} catch (SQLException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
			} finally {				
				try {
					con.close();
				} catch (SQLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}				
			}
			
			//判断跳转
			if(orderList.isEmpty()) {
				//跳转至错误页
				gotoPage("./views/errorPage.jsp", request, response);
			} else {
				//跳转至列表页
				gotoPage("./list_order.jsp", request, response);
			}
			
		}
		
		
		
		
	}
	
	/**
	 * 通用跳转页面
	 * @throws IOException 
	 * @throws ServletException 
	 * */
	public void gotoPage(String targetURL,HttpServletRequest request,HttpServletResponse response) throws ServletException, IOException {
		RequestDispatcher rd ;
		rd = request.getRequestDispatcher(targetURL);
		rd.forward(request, response);
	}
	

}
