package util;

import java.math.BigDecimal;

/**
 * 钱数转换：钱数float类型保留小数点后两位，后两位进行四舍五入
 * 例如：float money = 34.0934f;
 * 那么转换后保留小数点后两位，后两位进行四舍五入结果为：34.10
 * */
public class TransformationMoney {
	/**
	 * 第一种方法实现保留小数点后两位，并且后两位后面>=5进1；
	 * */
	public float transformationMoney(float money) {		 
	   //2.23  四舍五入（若舍弃部分>=.5，就进位）
	   BigDecimal d = new BigDecimal(money).setScale(2, BigDecimal.ROUND_HALF_UP);
	    	  money = d.floatValue() ;
		return money;
	}
	
	/**
	 * 第二种方法实现保留小数点后两位，并且后两位后面>=5进1；
	 * */
	public float transformationMoneyMethod(float money) {
		int scale = 2;		//设置位数  
		int roundingMode = 4;//表示四舍五入，可以选择其他舍值方式，例如去尾，等等.  
		BigDecimal   bd = new   BigDecimal((double)money);  
		             bd = bd.setScale(scale,roundingMode);  
		       money = bd.floatValue();  
		return money;
	}
}
